<?php
/**
 * Copyright (c) 2012-2016, Agence Française Informatique (AFI). All rights reserved.
 *
 * LINSE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU AFFERO GENERAL PUBLIC LICENSE as published by
 * the Free Software Foundation.
 *
 * There are special exceptions to the terms and conditions of the AGPL as it
 * is applied to this software (see README file).
 *
 * LINSE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU AFFERO GENERAL PUBLIC LICENSE for more details.
 *
 * You should have received a copy of the GNU AFFERO GENERAL PUBLIC LICENSE
 * along with LINSE; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
 */


class Linse_Converter {
  protected $_ascii_to_uppercase = [];
  protected $_ascii_map = [];


  public function __construct() {
    $this->_ascii_to_uppercase = str_split(str_repeat(' ', 42)
                                           . '*     0123456789       '
                                           . 'ABCDEFGHIJKLMNOPQRSTUVWXYZ      '
                                           . 'ABCDEFGHIJKLMNOPQRSTUVWXYZ      '
                                           . str_repeat(' ', 63)
                                           .'AAAAAAACEEEEIIII NOOOOO  UUUUY  AAAAAAACEEEEIIII NOOOOO  UUUUY Y');

    for ($i=0; $i < count($this->_ascii_to_uppercase); $i++)
      $this->_ascii_map[] = chr($i);
  }


  public function toIndexable($data, $compact=true) {
    $ascii = trim(str_replace($this->_ascii_map,
                              $this->_ascii_to_uppercase,
                              $data));

    return $compact
      ? preg_replace('/\s+/', ' ', $ascii)
      : $ascii;
  }
}