<?php
/**
 * Copyright (c) 2012-2014, Agence Française Informatique (AFI). All rights reserved.
 *
 * BOKEH is free software; you can redistribute it and/or modify
 * it under the terms of the GNU AFFERO GENERAL PUBLIC LICENSE as published by
 * the Free Software Foundation.
 *
 * There are special exceptions to the terms and conditions of the AGPL as it
 * is applied to this software (see README file).
 *
 * LINSE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU AFFERO GENERAL PUBLIC LICENSE for more details.
 *
 * You should have received a copy of the GNU AFFERO GENERAL PUBLIC LICENSE
 * along with LINSE; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
 */


class Linse_Utf8Converter extends Linse_Converter {
  protected $tableMajUtf8 = ['É' => 'E',
                             'È' => 'E',
                             'Ë' => 'E',
                             'Ê' => 'E',
                             'Á' => 'A',
                             'À' => 'A',
                             'Ä' => 'A',
                             'Â' => 'A',
                             'Å' => 'A',
                             'Ã' => 'A',
                             'Æ' => 'AE',
                             'Ï' => 'I',
                             'Î' => 'I',
                             'Ì' => 'I',
                             'Í' => 'I',
                             'Ô' => 'O',
                             'Ö' => 'O',
                             'Ò' => 'O',
                             'Ó' => 'O',
                             'Õ' => 'O',
                             'Ø' => 'O',
                             'Œ' => 'OE',
                             'Ú' => 'U',
                             'Ù' => 'U',
                             'Û' => 'U',
                             'Ü' => 'U',
                             'Ñ' => 'N',
                             'Ç' => 'C',
                             '¿' => '',
                             'Ł' => 'L',
                             'Ż' => 'Z',
                             'Đ' => 'D', // d slash upper != eth upper
                             'Ĳ' => 'IJ',
                             'Þ' => 'TH',
                             'Ð' => 'D', // eth upper != d slash upper
                             'ß' => 'SS',
      ];


  public function toIndexable($data, $compact=true) {
    $data = mb_strtoupper($data);
    $data = str_replace(array_keys($this->tableMajUtf8),
                        array_values($this->tableMajUtf8),
                        $data);
    $data = utf8_decode($data);

    return parent::toIndexable($data, $compact);
  }
}